%define pemdir %{_sysconfdir}/ssl/stunnel

%define major 0
%define libname %mklibname %{name} %{major}
%define libname_devel %mklibname %{name} -d
%define libname_static_devel %mklibname %{name} -d -s

Summary:	Program that wraps normal socket connections with SSL/TLS
Name:		stunnel
Version:	4.34
Release:	%mkrel 1
License:	GPLv2
Group:		System/Servers
URL:		http://www.stunnel.org/
Source0:	http://www.stunnel.org/download/stunnel/src/%{name}-%{version}.tar.xz
Source1:	http://www.stunnel.org/download/stunnel/src/%{name}-%{version}.tar.gz.asc
Source2:	http://www.stunnel.org/download/stunnel/src/%{name}-%{version}.tar.gz.sha1
Patch0:		stunnel-4.34-path-fix.patch
Patch1:		stunnel-4.34-lib64.patch
BuildRequires:	libtool
BuildRequires:	automake1.7
BuildRequires:	autoconf2.5
BuildRequires:	openssl >= 0.9.5
BuildRequires:	openssl-devel >= 0.9.5
BuildRequires:	tcp_wrappers-devel
Requires:	openssl >= 0.9.5a
Requires:	tcp_wrappers
Requires:	%{libname} >= %{version}
BuildRoot:	%{_tmppath}/%{name}-%{version}-%{release}-buildroot

%description
The stunnel program is designed to work as SSL encryption wrapper between 
remote clients and local (inetd-startable) or remote servers. The concept is 
that having non-SSL aware daemons running on your system you can easily set 
them up to communicate with clients over secure SSL channels.

stunnel can be used to add SSL functionality to commonly used inetd daemons 
like POP-2, POP-3, and IMAP servers, to standalone daemons like NNTP, SMTP 
and HTTP, and in tunneling PPP over network sockets without changes to the 
source code.

%package -n	%{libname}
Summary:	Shared library for stunnel
Group:		System/Libraries

%description -n	%{libname}
The stunnel program is designed to work as SSL encryption wrapper between 
remote clients and local (inetd-startable) or remote servers. The concept is 
that having non-SSL aware daemons running on your system you can easily set 
them up to communicate with clients over secure SSL channels.

stunnel can be used to add SSL functionality to commonly used inetd daemons 
like POP-2, POP-3, and IMAP servers, to standalone daemons like NNTP, SMTP 
and HTTP, and in tunneling PPP over network sockets without changes to the 
source code.

This package contains the shared library for stunnel.

%package -n	%{libname_devel}
Summary:	Development files for stunnel
Group:		Development/C
Requires:	%{libname} = %{version}-%{release}
Provides:	lib%{name}-devel = %{version}-%{release}
Provides:	%{name}-devel = %{version}-%{release}
Obsoletes:	%{libname}-devel < %{version}-%{release}

%description -n	%{libname_devel}
The stunnel program is designed to work as SSL encryption wrapper between 
remote clients and local (inetd-startable) or remote servers. The concept is 
that having non-SSL aware daemons running on your system you can easily set 
them up to communicate with clients over secure SSL channels.

stunnel can be used to add SSL functionality to commonly used inetd daemons 
like POP-2, POP-3, and IMAP servers, to standalone daemons like NNTP, SMTP 
and HTTP, and in tunneling PPP over network sockets without changes to the 
source code.

This package contains development files for stunnel.

%package -n	%{libname_static_devel}
Summary:	Static library for stunnel
Group:		Development/C
Requires:	%{libname_devel} = %{version}-%{release}
Provides:	lib%{name}-static-devel = %{version}-%{release}
Provides:	%{name}-static-devel = %{version}-%{release}

%description -n	%{libname_static_devel}
The stunnel program is designed to work as SSL encryption wrapper between 
remote clients and local (inetd-startable) or remote servers. The concept is 
that having non-SSL aware daemons running on your system you can easily set 
them up to communicate with clients over secure SSL channels.

stunnel can be used to add SSL functionality to commonly used inetd daemons 
like POP-2, POP-3, and IMAP servers, to standalone daemons like NNTP, SMTP 
and HTTP, and in tunneling PPP over network sockets without changes to the 
source code.

This package contains the static library for stunnel.

%prep
%setup -q
%patch0 -p0 
%patch1 -p1 

iconv -f iso-8859-1 -t utf-8 < doc/stunnel.fr.8 > doc/stunnel.fr.8_
mv doc/stunnel.fr.8_ doc/stunnel.fr.8
iconv -f iso-8859-2 -t utf-8 < doc/stunnel.pl.8 > doc/stunnel.pl.8_
mv doc/stunnel.pl.8_ doc/stunnel.pl.8

# XXX don't install /var/lib/stunnel
perl -ni -e '/INSTALL.*-m 1770 -g nogroup.*stunnel$/ or print' tools/Makefile.am

%{__perl} -pi -e 's/\r$//g' INSTALL.WCE

%{_bindir}/autoreconf -i -v -f

%build
%configure2_5x \
    --with-threads=fork \
    --with-ssl=%{_prefix} \
    --enable-static \
    --enable-shared \
    --localstatedir=%{_var} \
    --with-tcp-wrappers \
    --with-ipv6
%make pkglibdir=%{_libdir}

%install
rm -rf %{buildroot}

mkdir -p %{buildroot}%{pemdir} \
        %{buildroot}%{_var}/openssl/certs/trusted \
        %{buildroot}%{_var}/run/stunnel

# (oe) hack... don't generate the pem file, and stunnel.conf
touch %{buildroot}%{pemdir}/stunnel.pem
%makeinstall docdir=`pwd`/doc-to-install pkglibdir=%{buildroot}%{_libdir}

%{__mkdir_p} %{buildroot}%{_datadir}/%{name}
%{__cp} -p tools/stunnel.cnf %{buildroot}%{_datadir}/%{name}/stunnel.cnf
cp %{buildroot}%{_sysconfdir}/%name/stunnel.conf-sample %{buildroot}%{_sysconfdir}/%name/stunnel.conf
# Move the translated man pages to the right subdirectories, and strip off the
# language suffixes.
for lang in fr pl ; do
        mkdir -p %{buildroot}%{_mandir}/${lang}/man8
        mv %{buildroot}%{_mandir}/man8/*.${lang}.8* %{buildroot}%{_mandir}/${lang}/man8/
        rename ".${lang}" "" %{buildroot}%{_mandir}/${lang}/man8/*
done

# cleanup
rm -f ./doc-to-install/INSTALL.W32
rm -f %{buildroot}%{pemdir}/*

%post
echo "To build a new pem, execute the following OpenSSL command:"
echo "    openssl req -new -x509 -days 365 -nodes \ "
echo "    -config %{_datadir}/%{name}/stunnel.cnf \ "
echo "    -out %{pemdir}/stunnel.pem -keyout %{pemdir}/stunnel.pem"
echo ""

%post -n %{libname}
/sbin/ldconfig

%postun -n %{libname}
/sbin/ldconfig


%clean
rm -rf %{buildroot}

%files
%defattr(-,root,root,0755)
%doc doc-to-install/*
%{_bindir}/stunnel
%{_bindir}/stunnel3
%{_datadir}/%{name}/
%dir %{pemdir}
%dir %{_var}/run/stunnel
%dir %{_var}/openssl/certs/trusted
%{_mandir}/man8/stunnel.8.*
%lang(fr) %{_mandir}/fr/man8/stunnel.8*
%lang(pl) %{_mandir}/pl/man8/stunnel.8*
%{_sysconfdir}/%{name}/stunnel.conf-sample
%{_sysconfdir}/%{name}/stunnel.conf
%{_sysconfdir}/%{name}/stunnel.pem

%files -n %{libname}
%defattr(-,root,root)
%{_libdir}/*

%files -n %{libname_devel}
%defattr(-,root,root)
%{_libdir}/*.so
%{_libdir}/*.la

%files -n %{libname_static_devel}
%{_libdir}/*.a


%changelog
* Mon Oct 18 2010 Texstar <texstar at gmail.com> 4.34-1pclos2010
- 4.34

* Sun Aug 15 2010 Texstar <texstar at gmail.com> 4.33-1pclos2010
- 4.33

* Sun Dec 13 2009 Texstar <texstar at gmail.com> 4.29-1pclos201
- update to new version 4.29
